'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _filter = require('lodash/collection/filter');

var _filter2 = _interopRequireDefault(_filter);

var _has = require('lodash/object/has');

var _has2 = _interopRequireDefault(_has);

var _map = require('lodash/collection/map');

var _map2 = _interopRequireDefault(_map);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getFunctionParameterNames = undefined,
    getJsdocParameterNames = undefined,
    getJsdocParameterNamesDeep = undefined;

getFunctionParameterNames = function (functionNode) {
    return (0, _map2.default)(functionNode.params, function (param) {
        if ((0, _has2.default)(param, 'name')) {
            return param.name;
        }

        if ((0, _has2.default)(param, 'left.name')) {
            return param.left.name;
        }

        throw new Error('Unsupported function signature format.');
    });
};

getJsdocParameterNamesDeep = function (jsdoc) {
    var jsdocParameterNames = undefined;

    jsdocParameterNames = (0, _filter2.default)(jsdoc.tags, {
        tag: 'param'
    });

    jsdocParameterNames = (0, _map2.default)(jsdocParameterNames, 'name');

    return jsdocParameterNames;
};

getJsdocParameterNames = function (jsdoc) {
    var jsdocParameterNames = undefined;

    jsdocParameterNames = getJsdocParameterNamesDeep(jsdoc);

    jsdocParameterNames = (0, _filter2.default)(jsdocParameterNames, function (name) {
        return name.indexOf('.') === -1;
    });

    return jsdocParameterNames;
};

exports.default = {
    getFunctionParameterNames: getFunctionParameterNames,
    getJsdocParameterNames: getJsdocParameterNames,
    getJsdocParameterNamesDeep: getJsdocParameterNamesDeep
};
module.exports = exports['default'];
//# sourceMappingURL=jsdocUtils.js.map
